프로젝트

일반

사용자정보

통계
| 브랜치(Branch): | 개정판:

hytos / DTI_PID / SPPIDConverter / ConverterDocking.cs @ dc5c5b3c

이력 | 보기 | 이력해설 | 다운로드 (17 KB)

1
using System;
2
using System.Collections.Generic;
3
using System.ComponentModel;
4
using System.Drawing;
5
using System.Data;
6
using System.Linq;
7
using System.Text;
8
using System.Threading.Tasks;
9
using System.Windows.Forms;
10
using System.Threading;
11
using System.IO;
12
using Microsoft.VisualBasic;
13
using Ingr.RAD2D;
14
using Converter.BaseModel;
15
using Converter.SPPID.Properties;
16
using Converter.SPPID.DB;
17
using Converter.SPPID.Util;
18
using Converter.SPPID.Form;
19
using Converter.SPPID.Model;
20
using Plaice;
21
using Llama;
22
using DevExpress.XtraSplashScreen;
23
using Newtonsoft.Json;
24
using System.Runtime.InteropServices;
25
using System.Reflection;
26
using Converter.SPPID.OPC;
27

    
28
namespace Converter.SPPID.Wrapper
29
{
30
    public partial class ConverterDocking : UserControl
31
    {
32
        Ingr.RAD2D.Application application;
33
        static bool addEvent = false;
34
        public ConverterDocking()
35
        {
36
            InitializeComponent();
37

    
38
            dynamic dApplication = Interaction.GetObject("", "PIDAutomation.Application");
39
            WrapperApplication wApp = new WrapperApplication(dApplication.Application);
40
            application = wApp.RADApplication;
41
            
42
            ReleaseCOMObjects(dApplication);
43
            dApplication = null;
44
            try
45
            {
46
                textEditDrawingX.EditValue = Settings.Default.DrawingX;
47
                textEditDrawingY.EditValue = Settings.Default.DrawingY;
48

    
49
                Project_Info _ProjectInfo = Project_Info.GetInstance();
50
                _ProjectInfo.DefaultPath = Settings.Default.ProjectPath;
51
                _ProjectInfo.DBType = (ID2DB_Type)Settings.Default.ProjectDBType;
52
                _ProjectInfo.ServerIP = Settings.Default.ProjectServerIP;
53
                _ProjectInfo.Port = Settings.Default.ProjectPort;
54
                _ProjectInfo.DBUser = Settings.Default.ProjectDBUser;
55
                _ProjectInfo.DBPassword = Settings.Default.ProjectDBPassword;
56

    
57
                if (!addEvent)
58
                {
59
                    application.EventObject.BeforeApplicationExit += ApplicationEvents_ApplicationExit;
60
                    addEvent = true;
61
                }
62
                RegisterHotKey(this.Handle, 0, (int)KeyModifier.Shift, Keys.A.GetHashCode());
63
            }
64
            catch (Exception ex)
65
            {
66
                StringBuilder sb = new StringBuilder();
67
                sb.AppendLine(ex.Message);
68
                sb.AppendLine(ex.StackTrace);
69
                MessageBox.Show(sb.ToString());
70
            }
71
        }
72
        private void ApplicationEvents_ApplicationExit(out bool cancel)
73
        {
74
            cancel = false;
75
        }
76
        /// <summary>
77
        /// 선택한 도면들을 읽어서 SPPID로 변환한다.
78
        /// </summary>
79
        /// <param name="sender"></param>
80
        /// <param name="e"></param>
81
        private void btnConverter_Click(object sender, EventArgs e)
82
        {
83
            ConverterForm converterForm = new ConverterForm();
84
            if (converterForm.ShowDialog() == DialogResult.OK)
85
            {
86
                //Ingr.RAD2D.Document doc = application.Documents.Add();
87

    
88
                try
89
                {
90
                    CloseOPCForm.Run();
91

    
92
                    for (int i = 0; i < converterForm.Documents.Count; i++)
93
                    {
94
                        SPPID_Document document = converterForm.Documents[i];
95
                        if (document.SetSPPIDMapping() && document.Enable)
96
                        {
97
                            using (AutoModeling modeling = new AutoModeling(document, converterForm.checkEditCloseDocument.Checked))
98
                            {
99
                                modeling.DocumentLabelText = string.Format("Drawing Name : {0} ({1}/{2})", document.DrawingName, i + 1, converterForm.Documents.Count);
100
                                modeling.Run();
101
                            }
102
                        }
103
                    }
104
                }
105
                catch (Exception ex)
106
                {
107
                    MessageBox.Show(ex.Message + "\r\n" + ex.StackTrace);
108
                }
109
                finally
110
                {
111
                    CloseOPCForm.Stop();
112

    
113
                    //doc.SaveOnClose = false;
114
                    //doc.Close(false);
115

    
116
                    //dynamic dApplication = Interaction.GetObject("", "PIDAutomation.Application");
117
                    //dApplication.Drawings[1].CloseDrawing(false);
118
                    //ReleaseCOMObjects(dApplication);
119
                    //dApplication = null;
120
                }
121

    
122
                MessageBox.Show(Msg.EndConvert, Msg.Information, MessageBoxButtons.OK, MessageBoxIcon.Information);
123
            }
124
        }
125

    
126
        private void btnLinkOPC_Click(object sender, EventArgs e)
127
        {
128
            DataTable tOPCInfo = Project_DB.SelectOPCInfo();
129
            DataTable tOPCRelations = Project_DB.SelectOPCRelations();
130
            DataTable tDrawingInfo = Project_DB.SelectDrawingInfo();
131
            dynamic dApplication = Interaction.GetObject("", "PIDAutomation.Application");
132

    
133
            foreach (DataRow row in tOPCInfo.Rows)
134
            {
135
                if (!Convert.ToBoolean(row["PAIRED"]))
136
                {
137
                    string drawingUID = row["ID2_DRAWING_UID"].ToString();
138
                    string OPCUID = row["ID2_OPC_UID"].ToString();
139
                    DataRow[] rows = tOPCRelations.Select(string.Format("(From_Drawings_UID = '{0}' AND From_OPC_UID = '{1}') OR (To_Drawings_UID = '{0}' AND To_OPC_UID = '{1}')", drawingUID, OPCUID));
140

    
141
                    if (rows.Length == 2)
142
                    {
143
                        string fromDrawingsUID1 = rows[0]["From_Drawings_UID"].ToString();
144
                        string fromDrawingsUID2 = rows[1]["From_Drawings_UID"].ToString();
145
                        string fromOPCUID1 = rows[0]["From_OPC_UID"].ToString();
146
                        string fromOPCUID2 = rows[1]["From_OPC_UID"].ToString();
147
                        string toDrawingsUID1 = rows[0]["To_Drawings_UID"].ToString();
148
                        string toDrawingsUID2 = rows[1]["To_Drawings_UID"].ToString();
149
                        string toOPCUID1 = rows[0]["To_OPC_UID"].ToString();
150
                        string toOPCUID2 = rows[1]["To_OPC_UID"].ToString();
151

    
152
                        DataRow[] fromDrawing = tDrawingInfo.Select(string.Format("ID2_DRAWING_UID = '{0}'", fromDrawingsUID1));
153
                        DataRow[] toDrawing = tDrawingInfo.Select(string.Format("ID2_DRAWING_UID = '{0}'", toDrawingsUID1));
154
                        DataRow[] fromOPCInfoRows = tOPCInfo.Select(string.Format("ID2_OPC_UID = '{0}'", fromOPCUID1));
155
                        DataRow[] toOPCInfoRows = tOPCInfo.Select(string.Format("ID2_OPC_UID = '{0}'", toOPCUID1));
156

    
157
                        if (fromOPCUID1 == toOPCUID2 && fromOPCUID2 == toOPCUID1 && fromDrawing.Length == 1 && toDrawing.Length == 1 && fromOPCInfoRows.Length == 1 && toOPCInfoRows.Length == 1)
158
                        {
159
                            DataRow fromOPCInfoRow = fromOPCInfoRows[0];
160
                            DataRow toOPCInfoRow = toOPCInfoRows[0];
161
                            string fromOPCModelId = fromOPCInfoRow["SPPID_OPC_MODELITEM_ID"].ToString();
162
                            string toOPCModelId = toOPCInfoRow["SPPID_OPC_MODELITEM_ID"].ToString();
163
                            string toDrawingName = toDrawing[0]["DRAWINGNAME"].ToString();
164
                            List<string[]> toOPCAttributes = JsonConvert.DeserializeObject<List<string[]>>(toOPCInfoRow["ATTRIBUTES"].ToString());
165
                            AutoModeling_OPC opc = new AutoModeling_OPC(dApplication, application, fromOPCModelId, toOPCModelId, toDrawingName, toOPCAttributes);
166
                            if (opc.Run())
167
                            {
168
                                fromOPCInfoRow["PAIRED"] = true;
169
                                toOPCInfoRow["PAIRED"] = true;
170

    
171
                                Project_DB.InsertOPCInfo(fromOPCInfoRow["ID2_OPC_UID"].ToString(), fromOPCInfoRow["SPPID_OPC_MODELITEM_ID"].ToString(), fromOPCInfoRow["ID2_DRAWING_UID"].ToString(), true);
172
                                Project_DB.InsertOPCInfo(toOPCInfoRow["ID2_OPC_UID"].ToString(), toOPCInfoRow["SPPID_OPC_MODELITEM_ID"].ToString(), toOPCInfoRow["ID2_DRAWING_UID"].ToString(), true);
173
                            }
174
                        }
175
                    }
176
                }
177
            }
178

    
179
            tOPCInfo.Dispose();
180
            tOPCRelations.Dispose();
181
            tDrawingInfo.Dispose();
182
            ReleaseCOMObjects(dApplication);
183
            dApplication = null;
184

    
185
            MessageBox.Show(Msg.EndConvert, Msg.Information, MessageBoxButtons.OK, MessageBoxIcon.Information);
186
        }
187

    
188
        public void ReleaseCOMObjects(params object[] objVars)
189
        {
190
            int intNewRefCount = 0;
191
            foreach (object obj in objVars)
192
            {
193
                if (!Information.IsNothing(obj) && System.Runtime.InteropServices.Marshal.IsComObject(obj))
194
                    intNewRefCount = intNewRefCount + System.Runtime.InteropServices.Marshal.FinalReleaseComObject(obj);
195
            }
196
        }
197

    
198
        private void btnGetDrawingSize_Click(object sender, EventArgs e)
199
        {
200
            dynamic application = Interaction.GetObject("", "PIDAutomation.Application");
201
            WrapperApplication wApp = new WrapperApplication(application.Application);
202
            Ingr.RAD2D.Application radApp = wApp.RADApplication;
203

    
204
            if (radApp.ActiveSelectSet.Count > 0)
205
            {
206
                DependencyObject line2D = radApp.ActiveSelectSet[0] as DependencyObject;
207
                if (line2D != null)
208
                {
209
                    double minX = 0;
210
                    double minY = 0;
211
                    double maxX = 0;
212
                    double maxY = 0;
213
                    line2D.Range(out minX, out minY, out maxX, out maxY);
214

    
215
                    Settings.Default.DrawingX = maxX - minX;
216
                    Settings.Default.DrawingY = maxY - minY;
217
                    Settings.Default.Save();
218

    
219
                    textEditDrawingX.EditValue = Settings.Default.DrawingX;
220
                    textEditDrawingY.EditValue = Settings.Default.DrawingY;
221
                }
222
                else
223
                    MessageBox.Show(Msg.SelectLine, Msg.Warning, MessageBoxButtons.OK, MessageBoxIcon.Warning);
224
            }
225
            else
226
                MessageBox.Show(Msg.SelectLine, Msg.Warning, MessageBoxButtons.OK, MessageBoxIcon.Warning);
227
        }
228

    
229
        #region SPPID Utils
230
        private void btnSymmetry_Click(object sender, EventArgs e)
231
        {
232

    
233
        }
234
        
235
        #region Hot Key
236
        [System.Runtime.InteropServices.DllImport("user32.dll")]
237
        private static extern bool RegisterHotKey(IntPtr hWnd, int id, int fsModifiers, int vk);
238
        [System.Runtime.InteropServices.DllImport("user32.dll")]
239
        private static extern bool UnregisterHotKey(IntPtr hWnd, int id);
240
        enum KeyModifier
241
        {
242
            None = 0,
243
            Alt = 1,
244
            Control = 2,
245
            Shift = 4,
246
            WinKey = 8
247
        }
248
        protected override void WndProc(ref Message m)
249
        {
250
            base.WndProc(ref m);
251
            if (m.Msg == 0x0312)
252
            {
253
                Keys key = (Keys)(((int)m.LParam >> 16) & 0xFFFF);
254
                KeyModifier modifier = (KeyModifier)((int)m.LParam & 0xFFFF);
255
                int id = m.WParam.ToInt32();
256
                application.RunCommand(CommandConstants.igcmdGridSnap);
257
            }
258

    
259
        }
260
        #endregion
261
        #endregion
262

    
263
        #region TEST
264

    
265
        private void simpleButton1_Click(object sender, EventArgs e)
266
        {
267
            Placement placement = new Placement();
268
            if (application.ActiveSelectSet.Count > 0)
269
            {
270
                string modelItemId = null;
271
                Symbol2d symbol2D = application.ActiveSelectSet[0] as Symbol2d;
272
                DependencyObject dependency = application.ActiveSelectSet[0] as DependencyObject;
273
                application.ActiveSelectSet.RemoveAll();
274
                if (symbol2D != null)
275
                {
276
                    return;
277
                    foreach (var attributes in symbol2D.AttributeSets)
278
                    {
279
                        foreach (var attribute in attributes)
280
                        {
281
                            if (attribute.Name == "ModelID")
282
                                modelItemId = attribute.GetValue().ToString();
283
                        }
284
                    }
285

    
286
                    if (modelItemId!=null)
287
                    {
288
                        LMADataSource dataSource = new LMADataSource();
289
                        LMModelItem modelItem = dataSource.GetModelItem(modelItemId);
290
                        foreach (LMRepresentation item in modelItem.Representations)
291
                        {
292
                            if (item.ModelItemID == modelItemId)
293
                            {
294
                                dataSource = placement.PIDDataSource;
295
                                LMSymbol symbol = dataSource.GetSymbol(item.Id);
296
                                double oldx = symbol.get_XCoordinate();
297
                                double oldy = symbol.get_YCoordinate();
298
                                symbol2D.Move(0, 0, 0, GridSetting.GetInstance().Length);
299

    
300
                                dataSource = new LMADataSource();
301
                                //dataSource = placement.PIDDataSource;
302
                                symbol = dataSource.GetSymbol(item.Id);
303
                                double x = symbol.get_XCoordinate();
304
                                double y = symbol.get_YCoordinate();
305
                            }
306
                        }
307
                    }
308
                }
309
                else if (dependency != null)
310
                {
311
                    foreach (dynamic item in dependency.DrawingObjects)
312
                    {
313
                        item.Move(0, 0, 0, GridSetting.GetInstance().Length);
314
                    }
315
                }
316
            }
317

    
318
            return;
319
            Thread outThread = new Thread(func2 =>
320
            {
321
                for (int i = 100; i < 120; i++)
322
                {
323
                    Thread thread = new Thread(func =>
324
                    {
325
                        dynamic application = Interaction.GetObject("", "PIDAutomation.Application");
326
                        //WrapperApplication wApp = new WrapperApplication(application.Application);
327
                        //Ingr.RAD2D.Application radApp = wApp.RADApplication;
328
                        dynamic drawing = application.Drawings.Add("Unit1", "D-Size.pid", i.ToString(), i.ToString());//application.Drawings.OpenDrawing("123");
329

    
330
                        Thread.Sleep(5000);
331

    
332
                        drawing.CloseDrawing(true);
333

    
334
                        //application.Quit();
335
                        ReleaseCOMObjects(application);
336
                        application = null;
337
                        ReleaseCOMObjects(drawing);
338
                        drawing = null;
339
                        Thread.Sleep(5000);
340
                    });
341
                    thread.Start();
342
                    thread.Join();
343
                }
344
            });
345
            outThread.Start();
346
            
347
            
348

    
349

    
350

    
351
            //radApp.Documents.Add(@"\\server70\DEVDOF1Site\GS\PLANT\PLANT1\Unit1\11111.pid");
352

    
353
            //radApp.ActiveDocument.Close(true);
354
            //drawing.CloseDrawing(true);
355

    
356
            //ReleaseCOMObjects(application);
357
            //ReleaseCOMObjects(drawing);
358
            //application = null;
359
            //wApp = null;
360
            //radApp = null;
361
            //drawing = null;
362
        }
363

    
364
        private void AutoJoinPipeRun()
365
        {
366
            dynamic application = Interaction.GetObject("", "PIDAutomation.Application");
367
            WrapperApplication wApp = new WrapperApplication(application.Application);
368
            Ingr.RAD2D.Application radApp = wApp.RADApplication;
369

    
370
            string modelItemId = null;
371
            List<double[]> vertices = new List<double[]>();
372
            if (radApp.ActiveSelectSet.Count == 0)
373
            {
374
                return;
375
            }
376
            dynamic OID = radApp.ActiveSelectSet[0].Key();
377
            DependencyObject drawingObject = radApp.ActiveDocument.ActiveSheet.DrawingObjects[OID];
378
            foreach (var attributes in drawingObject.AttributeSets)
379
            {
380
                foreach (var attribute in attributes)
381
                {
382
                    if (attribute.Name == "ModelID")
383
                        modelItemId = attribute.GetValue().ToString();
384
                }
385
            }
386
            radApp.ActiveSelectSet.RemoveAll();
387

    
388
        }
389
        #endregion
390

    
391

    
392
        [DllImport("user32.dll")]
393
        public static extern int FindWindow(string lpClassName, string lpWindowName);
394

    
395
        [DllImport("user32.dll", SetLastError = true)]
396
        static extern int GetWindowThreadProcessId(IntPtr hWnd, out int processId);
397

    
398
        private void ConverterDocking_Load(object sender, EventArgs e)
399
        {
400
#if DEBUG
401
            this.layoutControlItem2.Visibility = DevExpress.XtraLayout.Utils.LayoutVisibility.Always;
402
#else
403
            this.layoutControlItem2.Visibility = DevExpress.XtraLayout.Utils.LayoutVisibility.Never;
404
#endif
405

    
406
        }
407

    
408
        
409
    }
410
}
클립보드 이미지 추가 (최대 크기: 500 MB)